## Script (Python) "reindex_entry_mode"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: setNewEntryMode.py 1704 2007-04-24 18:15:34Z joachim $
"""
reindex students_catalog entry_mode index
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass

request = context.REQUEST
session = request.SESSION
response = request.RESPONSE
setheader = request.RESPONSE.setHeader
students = context.portal_url.getPortalObject().campus.students

def rwrite(s):
    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
    response.write("%s<br />\r\n" % s)

brains = context.portal_catalog(portal_type = 'Student')
count = 0
#set_trace()
for brain in brains:
    student_path = brain.getPath()
    sub_brains = context.portal_catalog(path = student_path)
    app_doc = None
    sc_doc = None
    for sb in sub_brains:
        if sb.getId == 'application':
            app_doc = sb.getObject().getContent()
        elif sb.getId == 'study_course':
            sc_doc = sb.getObject().getContent()
    if app_doc is None:
        continue
    em = getattr(app_doc,'entry_mode',None)
    new_em = "%s_ft" % em.lower()
    app_doc.edit(mapping={'entry_mode': new_em})
    if sc_doc:
        sc_doc.edit(mapping={'current_mode': new_em})
    count += 1
    s = "%d: %s %s -> %s" % (count,brain.getPath(),em,new_em)
    rwrite(s)
rwrite('Done')
